/* 
   astwar - AstWar is a terminal based 2D space shooter.

   Copyright (C) 2002 Frederico S. Munoz, Jorge Monteiro

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
*/

/*Part of the code used was taken from beep-1.2.2 from :
Johnathan Nightingale, 2000. http://johnath.com/  or johnath@johnath.com
Thank you Johnathan*/


#include <fcntl.h>
#include <getopt.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#ifdef __linux__
#include <sys/ioctl.h>
#include <linux/kd.h>
#endif
#include <sys/types.h>
#include <linux/kd.h>
#include <unistd.h>
#include <pthread.h>
#include "astbeep.h"


struct sounds fire = {0,0,0,0,"cXBXXC"};

struct sounds begin = {100,3,0,0,"cxcxcxcB"};

/*this is a temporary structure type sounds to hold the sound settings*/
struct sounds tempsound;

int console_fd = -1;

void 
playsound (char sound) 
{
#ifdef __linux__
  
  char * ttyname (int FILEDES);
  int i; 
  char note;
  float freq;
  /*Flag to play or not*/
  int play=1;

  /*I think that tty name shouldn't be more than 500 char long .. I HOPE*/
  char tty[500];

  /*Copy the content of the string returned by the tty function to tty*/
  strcpy(tty,ttyname(STDIN_FILENO));



  /*Update here when new sound added*/
  switch (sound)
    {
    case 'f':
      tempsound=fire;
      break;
    case 'b':
      tempsound=begin;
    default:
      play=0;
      break;
    }
  
  if(play==1)
    {
      if((console_fd = open(tty, O_WRONLY)) == -1) {
	/*NO SOUND AVAILABLE*/
	exit(1);
      }
      
      for (i = 0; tempsound.notes[i]!='\0'; i++) {     
        note=tempsound.notes[i];
	switch (note){
	case 'c':
	  freq=261.6;
	  break;
	case 'D':
	  freq=293.7;
	  break; 
	case 'E':
	  freq=329.6;
	  break;
	case 'F':
	  freq=349.2;
	  break;
	case 'G':
	  freq=392.0;
	  break;
	case 'A':
	  freq=440.0;
	  break;
	case 'B':
	  freq=493.9;
	  break;
	case 'C':
	  freq=523.2;
	  break;
	default:
	  freq=0;
	  break;
	}
	if(ioctl(console_fd, KIOCSOUND, (int)(CLOCK_TICK_RATE/freq)) < 0) {
	  printf("\a"); 
	}
	
	
	usleep(1000*tempsound.length);          
	ioctl(console_fd, KIOCSOUND, 0);
	if(tempsound.end_delay || (i+1 < tempsound.reps))
	  usleep(1000*tempsound.delay);       
	
      }                              
      
      close(console_fd);
    }
  pthread_exit(0);
#endif
}

