/* 
   astwar - terminal based 2D space shooter.

   Copyright (C) 2002 Frederico S. Munoz, Jorge Monteiro

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
*/



#include <stdio.h>
#include <curses.h>
#include "general.h"

#include "movement.h"

void
move_down (struct ship *mship)
{
  int mrow = mship->row;
  int mcol = mship->col;
  int new_row = mrow + 1;
  
  

  if (mrow < (LINES - 2))
    {
      if (mship->nprints > 210)
	{
	  mvaddstr (new_row, mcol, "*"); /* print the ship */
	  mvaddstr (mrow, mcol, " "); /* delete previous position of the ship */
	  mrow = new_row;
	  mship->row = new_row;
	  mship->nprints = 0;
	}
      else 
	{
	  mvaddstr (mrow, mcol, "*"); /* print the ship */
	  mship->nprints += 1;
	}
    }
}

void
move_up (struct ship *mship)
{
  int mrow = mship->row;
  int mcol = mship->col;
  int new_row = mrow - 1;
  if (mrow > 1)
    {
      if (mship->nprints > 210)
	{
	  mvaddstr (new_row, mcol, "*"); /* print the ship */
	  mvaddstr (mrow, mcol, " "); /* delete previous position of the ship */
	  mship->row = new_row;
	  mship->nprints = 0;
	}
      else 
	{
	  mvaddstr (mrow, mcol, "*"); /* print the ship */
	  mship->nprints += 1;
	}
    }
}

