/* 
   astwar - terminal based 2D space shooter.

   Copyright (C) 2002 Frederico S. Munoz, Jorge Monteiro

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
*/


#include <stdio.h>
#include <curses.h>
#include <pthread.h>
#include "general.h"
#include "shoot.h"
#include "astbeep.h"

extern int last_shot1;		/* This is to store the number of
 				   active shots */
extern int last_shot2;
	
extern struct shot mshots1[20];	/* Struct that holds the shots */
extern struct shot mshots2[20];	/* Struct that holds the shots */
struct shot torpedo;
int score1 = 0;
int score2 = 0;
int shots_speed = 30;


pthread_t ps1;
pthread_t ps2;

void
shoot (struct ship *mship)
{
  
  int mrow = mship->row;
  int mcol = mship->col;
  register int t;

  if (mship->id == 1)
    {      
      for  (t = 0; t < 20; t++)
	{
	  if (mshots1[t].active == 0)
	    { 
	      mshots1[t].col = mcol + 2;
	      mshots1[t].row= mrow;
	      mshots1[t].fired = 0;
	      mshots1[t].active = 1;
	      //wmenu ("Shot fired ");
	      //printw ("at line %d and row %d\t", mshots1[t1].col, mshots1[t1].row);
	      //printw ("\tLines %d        ",LINES);
	      //printw ("Columns %d              ",COLS);
	      /* beep_main(); */
	      mship->nshots += 1;
#ifdef __linux__
	      pthread_create (&ps1, NULL, (void *) playsound, (void *) 'f');
#else
	      beep();
#endif
	      
	      wmenu ("Shots fired: ");
	      printw ("%d\t Shot t: %d    ", mship->nshots, t);
	      break;
	      //printw ("Score: %d", score1);
	      
	      //printw ("Number of shots fired:  %d", mship->nshots);
	    } 
	}
    }
  else if (mship->id == 2)
    {
      for  (t = 0; t < 20; t++)
	{
	  if (mshots2[t].active == 0)
	    { 
	      mshots2[t].col = mcol - 2;
	      mshots2[t].row= mrow;
	      mshots2[t].fired = 0;
	      mshots2[t].active = 1;
	      //wmenu ("Shot fired ");
	      //printw ("at line %d and row %d\t", mshots2[t2].col, mshots2[t2].row);
	      //printw ("Lines %d        ",LINES);
	      //printw ("Columns %d              ",COLS);
	      /* beep_main(); */
	      mship->nshots += 1;
#ifdef __linux__
	      pthread_create (&ps2, NULL, (void *) playsound, (void *) 'f');
#else
	      beep();
#endif
	      wmenu2 ("Shots fired: ");
	      printw ("%d\t", mship->nshots);
	      //printw ("Score: %d", score2);
	      break;
	      
	      //printw ("Number of shots fired:  %d", mship->nshots);
	      
	    }
	}
      
      /*printf ("Shot fired at %d row and %d col", my_shot.row,my_shot.col);
	my_refresh();*/
    }
}

void
draw_shots  (struct ship *mship)
{

  register int t;
  
  /* Loop trough all the shots ...*/
  
  if (mship->id == 1)
    {
      for (t=0; t < 20; t++)
	{
	  
	  int mrow = mshots1[t].row;
	  int mcol = mshots1[t].col;
	  int prev_col = mshots1[t].col - 1;
	  int active = mshots1[t].active;
	  
	  if (active == 1)
	    {
	      if (mcol < (COLS - 2))
		{
		  attrset(COLOR_PAIR(1));
		  mvaddstr (mrow, mcol, "-");
		  attrset(COLOR_PAIR(7));
 		  my_refresh();
		  if (mcol == (COLS / 2) + 1)
		    {
		      mvaddstr (mrow, prev_col, ".");
		    }
		  else
		    {
		      mvaddstr (mrow, prev_col, " ");
		    }
		  if (mshots1[t].fired == shots_speed)
		    {
		      mshots1[t].col +=  1;
		      mshots1[t].fired = 0;
		    }
		  mshots1[t].fired += 1;
		}
	      else
		{
		  mvaddstr (mrow, (COLS - 3), " ");
		  mshots1[t].active = 0;
		  
		}
	    } /* if (active) ... */
	  else 
	    {
	      //	      mshots1[t].active = 0;
	      //	      mvaddstr (mrow, mcol - 3, " ");
	    }
	}
    }
  /* NEW SHIP */
  if (mship->id == 2)
    {
      for (t=0; t < 20; t++)
	{
	  int mrow = mshots2[t].row;
	  int mcol = mshots2[t].col;
	  int prev_col = mshots2[t].col + 1;
	  int active = mshots2[t].active;
	  
	  if (active == 1)
	    {
	      if (mcol >  1)
		{
		  attrset(COLOR_PAIR(2));
		  mvaddstr (mrow, mcol , "-");
		  attrset(COLOR_PAIR(7));
		  my_refresh();
		  if (mcol == (COLS / 2 - 2) + 1)
		    {
		      mvaddstr (mrow, prev_col, ".");
		    }
		  else
		    {
		      mvaddstr (mrow, prev_col, " ");
		    }
		  if (mshots2[t].fired == shots_speed)
		    {
		      mshots2[t].col -=  1;
		      mshots2[t].fired = 0;
		    }
		  mshots2[t].fired += 1;
		}
	      else
		{
		  mvaddstr (mrow, 2, " ");
		  mshots2[t].active = 0;

		}
	    }
	  else 
	    {
	        mshots2[t].active = 0;
	      //mvaddstr (mrow, mcol +1, " ");
	    }
	}
    }
}


void
storp (struct ship * mship)
{
  torpedo.row = mship->row;
  torpedo.col = mship->col +2;
  torpedo.active = 1;
  torpedo.fired = 0;
  wmenu("Torpedo Fired!!!");
}

void
shoot_torpedo  (struct ship *mship)
{
  int prow= torpedo.row;
  int pcol = torpedo.col;
  
 
  if (torpedo.active == 1)
    {
      if (torpedo.col < (COLS / 2))  
	{
	  torpedo.row = mship->row;
	  mvaddstr(prow, pcol, " ");

	 
	  if (torpedo.fired == shots_speed + 260)
	    {
	      torpedo.col +=  1;
	      torpedo.fired = 0;
	    }
	  torpedo.fired += 1;
	  mvaddstr (torpedo.row,torpedo.col, "=");
	} 
      else if (torpedo.col < (COLS - 2))
	{
	  
	  mshots1[17].col = torpedo.col;
	  mshots1[17].row= torpedo.row;
	  mshots1[17].fired = 0;
	  mshots1[17].active = 1;
	  
	  mshots1[18].col = torpedo.col;
	  mshots1[18].row= torpedo.row - 1;
	  mshots1[18].fired = 0;
	  mshots1[18].active = 1;
	  
	  mshots1[19].col = torpedo.col;
	  mshots1[19].row= torpedo.row + 1;
	  mshots1[19].fired = 0;
	  mshots1[19].active = 1;
	  


	  torpedo.active=0;
          mvaddstr(prow, pcol, " ");
	  /*
          if (torpedo.fired == shots_speed)
            {
              torpedo.col +=  1;
              torpedo.fired = 0;
            }
          torpedo.fired += 1;
          mvaddstr (torpedo.row,torpedo.col, "=");
	  */
	}
    }
}
void
shot_explosion (void)
{



}
